--  v1.4
macroScript waRp_Mirror
category:"waRp Tools" 
buttonText:"waRp Mirror"
tooltip:"waRp Mirror"
icon:#("warp_tools_mirror",1)
(
	rollout waRp_Mirror "waRp Mirror" width:144 height:228
	(
		groupBox gb_axis "Axis" pos:[8,11] width:127 height:45
		radioButtons rb_axis "" pos:[22,28] width:97 height:16 labels:#("X", "Y", "Z") columns:3
		groupBox gb_clone "Clone Selection" pos:[9,62] width:127 height:60
		radioButtons rb_clone "" pos:[20,81] width:64 height:32 labels:#("Copy", "No Clone") columns:1
		checkbox cb_FlipUVs "Flip UVs" pos:[18,144] width:80 height:20
		button btn_mirror "Mirror" pos:[41,195] width:61 height:25
		groupBox grp_Texturing "Texturing" pos:[9,127] width:127 height:60
		checkbox cb_CopyMtls "Copy Materials" pos:[18,162] width:104 height:20
		
		on rb_clone changed stat do
		(
			if rb_clone.state == 2 then
			(
				cb_CopyMtls.checked = false
				cb_CopyMtls.enabled = false
			)
			else
			(
				cb_CopyMtls.enabled = true
			)
		)
		
		fn mirrorSelection axis center clone OrigNodes = 
		if selection.count != 0 do
		(	
				local ax = case axis of (
				(1): [-1,1,1]
				(2): [1,-1,1]
				(3): [1,1,-1]
			)
			local parentslist = #()
			
			if clone == 1 then
				maxOps.CloneNodes (selection as array) offset:[0,0,0] cloneType:clone newNodes:&selNodes
			else
				selNodes=OrigNodes
			
			for i in SelNodes do (append parentslist i.parent ; i.parent = undefined)
			about center scale SelNodes ax
			
			--- XFORM MODIFIER ---
			resetXform SelNodes
			--- ---
			
			--- NORMAL MODIFIER ---
			myNormal = Normalmodifier()
			myNormal.flip=true
			addmodifier SelNodes(myNormal)
			--- ---
			
			-- collapse objects
			ConvertToPoly(SelNodes)  
			Cons = for con in SelNodes where (iskindof con Container) collect con
				CollapseStack Cons
			
			
			
			for i = 1 to SelNodes.count do SelNodes[i].parent = parentslist[i]
			free parentslist
			
			selNodes
		)
		
		fn findMtls TheObjs = 
		(
			
			mtls= #()
			for obj in theObjs do
				append mtls obj.material
			
			makeUniqueArray mtls
			
			mtls
		)
		
		
		fn makeDuplicateMtl OrigMtl = 
		(
			
			mtl1 = copy OrigMtl
			mtl1.name= OrigMtl.name+"_mirror"
			
			theObjs = #()
			theObjs = for n in (refs.dependents OrigMtl) where SuperClassOf n == GeometryClass and ((findString n.name "_mirror" ) != undefined ) collect n
			
			theObjs.material= mtl1
		
		)
		
		
		fn CopyMaterials Objs =
		(
			
			for obj in Objs do 
				obj.name += "_mirror" 
			
			materials = #()
			materials = findMtls Objs
			
			for mtl in materials do
			(
				if mtl != undefined then
					makeDuplicateMtl mtl
			)
		)

		
		fn FlipUVs Objs =
		(
			select Objs 
			max modify mode
			uvw = unwrap_UVW()
			modpanel.addmodtoselection(uvw)

			subobjectLevel = 3
			uvw.selectinvertedFaces()
			uvw.ScaleSelectedXY -1 1 [0.5,0.5,0]
			subobjectLevel = 0
			
			ConvertToPoly(objs)
		)
		
		
		on btn_mirror pressed  do
		(
			try 
				macros.run "waRp Tools" "waRp_RemoveTurbo"
			catch
				messagebox "waRp RemoveTurbo script NOT FOUND!!" title:"Script Not Found"
			
			OriginalNodes= getCurrentselection()
			
			ParentCon = for obj in OriginalNodes where (iskindof obj Container) and (obj.parent == undefined) collect obj
			
			if ParentCon.count == 0 then
			(
				ParentCon = OriginalNodes
			)
			
			
			MirrorNodes = mirrorSelection  rb_axis.state  ParentCon[1].pivot  rb_clone.state OriginalNodes
			
			OnlyGeo = for obj in MirrorNodes where superclassof obj == GeometryClass collect obj
			if cb_FlipUVs.state == true then
				FlipUVs OnlyGeo
			
			if cb_CopyMtls.state == true then
				CopyMaterials OnlyGeo	
								
			if rb_clone.state == 1 then
			(
				for i = 1 to MirrorNodes.count do -- stavi gi originalnite iminja na mirror-iranite objekti
				(
					MirrorNodes[i].name = OriginalNodes[i].name
				)
			)
			
			DestroyDialog waRp_Mirror
		)
	)
	on execute do
	(
		if selection.count >= 1 then
			createDialog waRp_Mirror
		else
			messagebox "Select at least one object!" title: "waRp Mirror"
	)
)